package com.sun.corba.se.impl.ior;

import com.sun.corba.se.impl.encoding.EncapsOutputStream;
import sun.corba.OutputStreamFactory;
import com.sun.corba.se.spi.orb.ORB;
import com.sun.corba.se.spi.ior.WriteContents;
import com.sun.corba.se.impl.encoding.EncapsInputStream;
import sun.corba.EncapsInputStreamFactory;
import com.sun.corba.se.impl.encoding.CDROutputStream;
import java.util.Iterator;
import com.sun.corba.se.spi.ior.Identifiable;
import org.omg.CORBA_2_3.portable.OutputStream;
import org.omg.CORBA_2_3.portable.InputStream;
import com.sun.corba.se.spi.ior.IdentifiableFactoryFinder;
import java.util.List;

public class EncapsulationUtility
{
    private EncapsulationUtility() {
    }
    
    public static void readIdentifiableSequence(List list, IdentifiableFactoryFinder identifiableFactoryFinder, InputStream inputStream) {
        for (int read_long = inputStream.read_long(), i = 0; i < read_long; ++i) {
            list.add(identifiableFactoryFinder.create(inputStream.read_long(), inputStream));
        }
    }
    
    public static void writeIdentifiableSequence(List list, OutputStream outputStream) {
        outputStream.write_long(list.size());
        Iterator<Object> iterator = list.iterator();
        while (iterator.hasNext()) {
            Identifiable identifiable = (Identifiable)(Identifiable)iterator.next();
            outputStream.write_long(identifiable.getId());
            identifiable.write(outputStream);
        }
    }
    
    public static void writeOutputStream(OutputStream outputStream, OutputStream outputStream2) {
        byte[] byteArray = ((CDROutputStream)outputStream).toByteArray();
        outputStream2.write_long(byteArray.length);
        outputStream2.write_octet_array(byteArray, 0, byteArray.length);
    }
    
    public static InputStream getEncapsulationStream(InputStream inputStream) {
        byte[] octets = readOctets(inputStream);
        EncapsInputStream encapsInputStream = EncapsInputStreamFactory.newEncapsInputStream(inputStream.orb(), octets, octets.length);
        encapsInputStream.consumeEndian();
        return encapsInputStream;
    }
    
    public static byte[] readOctets(InputStream inputStream) {
        int read_ulong = inputStream.read_ulong();
        byte[] array = new byte[read_ulong];
        inputStream.read_octet_array(array, 0, read_ulong);
        return array;
    }
    
    public static void writeEncapsulation(WriteContents writeContents, OutputStream outputStream) {
        EncapsOutputStream encapsOutputStream = OutputStreamFactory.newEncapsOutputStream((ORB)outputStream.orb());
        encapsOutputStream.putEndian();
        writeContents.writeContents(encapsOutputStream);
        writeOutputStream(encapsOutputStream, outputStream);
    }
}
